
<!DOCTYPE html>
<html lang="en" dir="ltr">
<head>
  <meta charset="utf-8">
  <meta content="IE=edge,chrome=1" http-equiv="X-UA-Compatible">
  <meta content="width=device-width; initial-scale=1; maximum-scale=1" name="viewport">
  <title>JQuery Raty</title>
  <meta content="Washington Botelho" name="author">
  <meta content="jQuery Raty - A Star Rating Plugin" name="description">
  <meta content="jquery,plugin,rating,raty,voto,star,staring,classificacao,classificar,votar,plugin" name="keywords">
  <link type="text/css" rel="stylesheet" href="css/application.css">
  <script type="text/javascript" src="jquery.min.js"></script>
  <script type="text/javascript" src="jquery.raty.min.js"></script>
  <link href="/favicon.ico" rel="shortcut icon" type="image/x-icon">
</head>
<body>
  <div id="wrapper">
    <header role="banner">
      <div id="logo">
        <h1><a href="http://wbotelhos.com/raty" title="jQuery Raty">jQuery Raty</a></h1>
        <p>A Star Rating Plugin</p>
      </div>
    </header>
    <div id="container">
      <section role="main">
        <article>
          <h2 id="default">
            <a href="#default">Default</a>
          </h2>
          <p>You need just to have a <code>div</code> to build the Raty.</p>
          <div class="demo">
            <div id="default-demo"></div>
          </div>
<div class="highlight">
<pre>
<span class="nt">&lt;div</span> <span class="na">id=</span><span class="s">"star"</span><span class="nt">&gt;&lt;/div&gt;</span>
</pre>
</div>
<div class="highlight">
<pre>
<span class="nx">$</span><span class="p">(</span><span class="s1">'#star'</span><span class="p">).</span><span class="nx">raty</span><span class="p">();</span>
</pre>
</div>
          <h2 id="score">
            <a href="#score">Score</a>
          </h2>
          <p>
            Used when we want starts with saved rating.
          </p>
          <div class="demo">
            <div id="score-demo"></div>
          </div>
<div class="highlight">
<pre>
<span class="nx">$</span><span class="p">(</span><span class="s1">'#star'</span><span class="p">).</span><span class="nx">raty</span><span class="p">({</span> <span class="nx">score</span><span class="o">:</span> <span class="mi">3</span> <span class="p">});</span>
</pre>
</div>
          <h2 id="score-callback">
            <a href="#score-callback">Score callback</a>
          </h2>
          <p>
            If you need to start you <a href="#score">score</a> depending of a dynamic value, you can to use callback for it.<br/>
            You can pass any value for it, not necessarily a <code>data-</code> value. You can use a field value for example.<br />
          </p>
          <div class="demo">
            <div id="score-callback-demo" data-score="1"></div>
          </div>
  <script type="text/javascript">
    $(function() {
      $.fn.raty.defaults.path = 'img';
      //$('#default-demo').raty();
	  $('#default-demo').raty({
  click: function(score, evt) {
    alert('ID: ' + $(this).attr('id') + "\nscore: " + score + "\nevent: " + evt);
  }
});
      $('#score-demo').raty({ score: 3 });
    });
  </script>
